| AI Engine-ML Intrinsics User Guide (v2025.2)

Loading...
Searching...
No Matches
Data Structures
Extract/insert element
Vector Conversions

## Overview

These intrinsics allow inserting or extracting of an individual element into/from a vector.

Inserting can be done either by pushing in a new value at one end of the vector and shifting or replacing a specific element.

## Data Structures
union | cint16_cbfloat16_cnvt_t
union | cint32_cfloat32_cnvt_t

## Update element in a vector with a value
  Update element determined by idx in vector a by value b Parameters
  v | The vector containing the element to be updated
  b | value to update.
  idx | Index used to choose where to update in vector a
v64int8 | upd_elem (v64int8 v, int idx, int b)
v32int16 | upd_elem (v32int16 v, int idx, int b)
v16int32 | upd_elem (v16int32 v, int idx, int b)
v64uint8 | upd_elem (v64uint8 v, int idx, unsigned int b)
v32uint16 | upd_elem (v32uint16 v, int idx, unsigned int b)
v16uint32 | upd_elem (v16uint32 v, int idx, unsigned int b)
v32bfloat16 | upd_elem (v32bfloat16 v, int idx, bfloat16 b)
v16cint16 | upd_elem (v16cint16 v, int idx, cint16 b)
v8cint32 | upd_elem (v8cint32 v, int idx, cint32 b)
v128int4 | insert (v128int4 v, int idx, v2int4 b)
v128int4 | insert (v128int4 v, int idx, v4int4 b)
v128int4 | insert (v128int4 v, int idx, v8int4 b)
v128int4 | insert (v128int4 v, int idx, v16int4 b)
v64int8 | insert (v64int8 v, int idx, int b)
v64int8 | insert (v64int8 v, int idx, v2int8 b)
v64int8 | insert (v64int8 v, int idx, v4int8 b)
v64int8 | insert (v64int8 v, int idx, v8int8 b)
v32int16 | insert (v32int16 v, int idx, int b)
v32int16 | insert (v32int16 v, int idx, v2int16 b)
v32int16 | insert (v32int16 v, int idx, v4int16 b)
v16int32 | insert (v16int32 v, int idx, int b)
v16int32 | insert (v16int32 v, int idx, v2int32 b)
v128uint4 | insert (v128uint4 v, int idx, v2uint4 b)
v128uint4 | insert (v128uint4 v, int idx, v4uint4 b)
v128uint4 | insert (v128uint4 v, int idx, v8uint4 b)
v128uint4 | insert (v128uint4 v, int idx, v16uint4 b)
v64uint8 | insert (v64uint8 v, int idx, unsigned char b)
v64uint8 | insert (v64uint8 v, int idx, v2uint8 b)
v64uint8 | insert (v64uint8 v, int idx, v4uint8 b)
v64uint8 | insert (v64uint8 v, int idx, v8uint8 b)
v32uint16 | insert (v32uint16 v, int idx, unsigned short b)
v32uint16 | insert (v32uint16 v, int idx, v2uint16 b)
v32uint16 | insert (v32uint16 v, int idx, v4uint16 b)
v16uint32 | insert (v16uint32 v, int idx, unsigned int b)
v16uint32 | insert (v16uint32 v, int idx, v2uint32 b)
v16cint16 | insert (v16cint16 v, int idx, cint16 b)
v16cint16 | insert (v16cint16 v, int idx, v2cint16 b)
v32bfloat16 | insert (v32bfloat16 v, int idx, bfloat16 b)
v32bfloat16 | insert (v32bfloat16 v, int idx, v2bfloat16 b)
v32bfloat16 | insert (v32bfloat16 v, int idx, v4bfloat16 b)
v16float | insert (v16float v, int idx, float b)
v128int4 | insert (v128int4 v, int idx, unsigned long long b)
v64int8 | insert (v64int8 v, int idx, unsigned long long b)
v32int16 | insert (v32int16 v, int idx, unsigned long long b)
v16int32 | insert (v16int32 v, int idx, unsigned long long b)
v128uint4 | insert (v128uint4 v, int idx, unsigned long long b)
v64uint8 | insert (v64uint8 v, int idx, unsigned long long b)
v32uint16 | insert (v32uint16 v, int idx, unsigned long long b)
v16uint32 | insert (v16uint32 v, int idx, unsigned long long b)
v16cint16 | insert (v16cint16 v, int idx, unsigned long long b)
v32bfloat16 | insert (v32bfloat16 v, int idx, unsigned long long b)
v16float | insert (v16float v, int idx, unsigned long long b)
v8cint32 | insert (v8cint32 v, int idx, cint32 b)
v8cfloat | insert (v8cfloat v, int idx, cfloat b)
v16cbfloat16 | insert (v16cbfloat16 v, int idx, cbfloat16 b)
v32int32 | insert_element (v32int32 v, int idx, int b)
v32acc32 | insert_element (v32acc32 v, int idx, int b)
v16acc64 | insert_element (v16acc64 v, int idx, long long b)
v32int32 | upd_elem (v32int32 v, int idx, int b)
v32acc32 | upd_elem (v32acc32 v, int idx, int b)
v16acc64 | upd_elem (v16acc64 v, int idx, int b)

## Extract an element from a vector with dynamic sign
  Extract element determined by idx from vector a Parameters
  v | The vector from which the element will be extracted from
  idx | Index used to choose element in vector
  sign | Sign of the extracted data
v2int4 | ext_v2int4 (v128int4 v, int idx, int sign)
v4int4 | ext_v4int4 (v128int4 v, int idx, int sign)
v8int4 | ext_v8int4 (v128int4 v, int idx, int sign)
v16int4 | ext_v16int4 (v128int4 v, int idx, int sign)
char | ext_elem (v64int8 v, int idx, int sign)
v2int8 | ext_v2int8 (v64int8 v, int idx, int sign)
v4int8 | ext_v4int8 (v64int8 v, int idx, int sign)
v8int8 | ext_v8int8 (v64int8 v, int idx, int sign)
short | ext_elem (v32int16 v, int idx, int sign)
v2int16 | ext_v2int16 (v32int16 v, int idx, int sign)
v4int16 | ext_v4int16 (v32int16 v, int idx, int sign)
int | ext_elem (v16int32 v, int idx, int sign)
v2int32 | ext_v2int32 (v16int32 v, int idx, int sign)
v2uint4 | ext_v2uint4 (v128uint4 v, int idx, int sign)
v4uint4 | ext_v4uint4 (v128uint4 v, int idx, int sign)
v8uint4 | ext_v8uint4 (v128uint4 v, int idx, int sign)
v16uint4 | ext_v16uint4 (v128uint4 v, int idx, int sign)
unsigned char | ext_elem (v64uint8 v, int idx, int sign)
v2uint8 | ext_v2uint8 (v64uint8 v, int idx, int sign)
v4uint8 | ext_v4uint8 (v64uint8 v, int idx, int sign)
v8uint8 | ext_v8uint8 (v64uint8 v, int idx, int sign)
unsigned short | ext_elem (v32uint16 v, int idx, int sign)
v2uint16 | ext_v2uint16 (v32uint16 v, int idx, int sign)
v4uint16 | ext_v4uint16 (v32uint16 v, int idx, int sign)
unsigned int | ext_elem (v16uint32 v, int idx, int sign)
v2uint32 | ext_v2uint32 (v16uint32 v, int idx, int sign)
cint16 | ext_elem (v16cint16 v, int idx, int sign)
v2cint16 | ext_v2cint16 (v16cint16 v, int idx, int sign)
unsigned long long | ext_u64 (v128int4 v, int idx, int sign)
unsigned long long | ext_u64 (v64int8 v, int idx, int sign)
unsigned long long | ext_u64 (v32int16 v, int idx, int sign)
unsigned long long | ext_u64 (v16int32 v, int idx, int sign)
unsigned long long | ext_u64 (v128uint4 v, int idx, int sign)
unsigned long long | ext_u64 (v64uint8 v, int idx, int sign)
unsigned long long | ext_u64 (v32uint16 v, int idx, int sign)
unsigned long long | ext_u64 (v16uint32 v, int idx, int sign)
unsigned long long | ext_u64 (v16cint16 v, int idx, int sign)
unsigned long long | ext_u64 (v32bfloat16 v, int idx, int sign)
cint32 | ext_elem (v8cint32 v, int idx, int sign)
bfloat16 | ext_elem (v32bfloat16 v, int idx, int sign)
v2bfloat16 | ext_v2bfloat16 (v32bfloat16 v, int idx, int sign)
v4bfloat16 | ext_v4bfloat16 (v32bfloat16 v, int idx, int sign)
v2int4 | extract_v2int4 (v128int4 v, int idx, int sign)
v4int4 | extract_v4int4 (v128int4 v, int idx, int sign)
v8int4 | extract_v8int4 (v128int4 v, int idx, int sign)
v16int4 | extract_v16int4 (v128int4 v, int idx, int sign)
char | extract_elem (v64int8 v, int idx, int sign)
v2int8 | extract_v2int8 (v64int8 v, int idx, int sign)
v4int8 | extract_v4int8 (v64int8 v, int idx, int sign)
v8int8 | extract_v8int8 (v64int8 v, int idx, int sign)
short | extract_elem (v32int16 v, int idx, int sign)
v2int16 | extract_v2int16 (v32int16 v, int idx, int sign)
v4int16 | extract_v4int16 (v32int16 v, int idx, int sign)
int | extract_elem (v16int32 v, int idx, int sign)
v2int32 | extract_v2int32 (v16int32 v, int idx, int sign)
v2uint4 | extract_v2uint4 (v128uint4 v, int idx, int sign)
v4uint4 | extract_v4uint4 (v128uint4 v, int idx, int sign)
v8uint4 | extract_v8uint4 (v128uint4 v, int idx, int sign)
v16uint4 | extract_v16uint4 (v128uint4 v, int idx, int sign)
unsigned char | extract_elem (v64uint8 v, int idx, int sign)
v2uint8 | extract_v2uint8 (v64uint8 v, int idx, int sign)
v4uint8 | extract_v4uint8 (v64uint8 v, int idx, int sign)
v8uint8 | extract_v8uint8 (v64uint8 v, int idx, int sign)
unsigned short | extract_elem (v32uint16 v, int idx, int sign)
v2uint16 | extract_v2uint16 (v32uint16 v, int idx, int sign)
v4uint16 | extract_v4uint16 (v32uint16 v, int idx, int sign)
unsigned int | extract_elem (v16uint32 v, int idx, int sign)
v2uint32 | extract_v2uint32 (v16uint32 v, int idx, int sign)
cint32 | extract_elem (v8cint32 v, int idx, int sign)
cint16 | extract_elem (v16cint16 v, int idx, int sign)
v2cint16 | extract_v2cint16 (v16cint16 v, int idx, int sign)
bfloat16 | extract_elem (v32bfloat16 v, int idx, int sign)
v2bfloat16 | extract_v2bfloat16 (v32bfloat16 v, int idx, int sign)
v4bfloat16 | extract_v4bfloat16 (v32bfloat16 v, int idx, int sign)
float | extract_elem (v16float v, int idx, int sign)
float | extract_elem (v16float v, int idx)
float | get_lo (v1cfloat)
float | get_hi (v1cfloat)
cfloat | extract_elem (v8cfloat v, int idx)
cfloat | extract_elem (v8cfloat v, int idx, int sign)
cbfloat16 | extract_elem (v16cbfloat16 v, int idx)
cbfloat16 | extract_elem (v16cbfloat16 v, int idx, int sign)

## Extract an element from a vector
  Extract element determined by idx from vector a Parameters
  v | The vector from which the element will be extracted from
  idx | Index used to choose element in vector
v2int4 | ext_v2int4 (v128int4 v, int idx)
v4int4 | ext_v4int4 (v128int4 v, int idx)
v8int4 | ext_v8int4 (v128int4 v, int idx)
v16int4 | ext_v16int4 (v128int4 v, int idx)
char | ext_elem (v64int8 v, int idx)
v2int8 | ext_v2int8 (v64int8 v, int idx)
v4int8 | ext_v4int8 (v64int8 v, int idx)
v8int8 | ext_v8int8 (v64int8 v, int idx)
short | ext_elem (v32int16 v, int idx)
v2int16 | ext_v2int16 (v32int16 v, int idx)
v4int16 | ext_v4int16 (v32int16 v, int idx)
int | ext_elem (v16int32 v, int idx)
v2int32 | ext_v2int32 (v16int32 v, int idx)
v2uint4 | ext_v2uint4 (v128uint4 v, int idx)
v4uint4 | ext_v4uint4 (v128uint4 v, int idx)
v8uint4 | ext_v8uint4 (v128uint4 v, int idx)
v16uint4 | ext_v16uint4 (v128uint4 v, int idx)
unsigned char | ext_elem (v64uint8 v, int idx)
v2uint8 | ext_v2uint8 (v64uint8 v, int idx)
v4uint8 | ext_v4uint8 (v64uint8 v, int idx)
v8uint8 | ext_v8uint8 (v64uint8 v, int idx)
unsigned short | ext_elem (v32uint16 v, int idx)
v2uint16 | ext_v2uint16 (v32uint16 v, int idx)
v4uint16 | ext_v4uint16 (v32uint16 v, int idx)
unsigned int | ext_elem (v16uint32 v, int idx)
v2uint32 | ext_vu2int32 (v16uint32 v, int idx)
cint16 | ext_elem (v16cint16 v, int idx)
v2cint16 | ext_v2cint16 (v16cint16 v, int idx)
cint32 | ext_elem (v8cint32 v, int idx)
bfloat16 | ext_elem (v32bfloat16 v, int idx)
v2bfloat16 | ext_v2bfloat16 (v32bfloat16 v, int idx)
v4bfloat16 | ext_v4bfloat16 (v32bfloat16 v, int idx)
v2int4 | extract_v2int4 (v128int4 v, int idx)
v4int4 | extract_v4int4 (v128int4 v, int idx)
v8int4 | extract_v8int4 (v128int4 v, int idx)
v16int4 | extract_v16int4 (v128int4 v, int idx)
char | extract_elem (v64int8 v, int idx)
v2int8 | extract_v2int8 (v64int8 v, int idx)
v4int8 | extract_v4int8 (v64int8 v, int idx)
v8int8 | extract_v8int8 (v64int8 v, int idx)
short | extract_elem (v32int16 v, int idx)
v2int16 | extract_v2int16 (v32int16 v, int idx)
v4int16 | extract_v4int16 (v32int16 v, int idx)
int | extract_elem (v16int32 v, int idx)
v2int32 | extract_v2int32 (v16int32 v, int idx)
v2uint4 | extract_v2uint4 (v128uint4 v, int idx)
v4uint4 | extract_v4uint4 (v128uint4 v, int idx)
v8uint4 | extract_v8uint4 (v128uint4 v, int idx)
v16uint4 | extract_v16uint4 (v128uint4 v, int idx)
unsigned char | extract_elem (v64uint8 v, int idx)
v2uint8 | extract_v2uint8 (v64uint8 v, int idx)
v4uint8 | extract_v4uint8 (v64uint8 v, int idx)
v8uint8 | extract_v8uint8 (v64uint8 v, int idx)
unsigned short | extract_elem (v32uint16 v, int idx)
v2uint16 | extract_v2uint16 (v32uint16 v, int idx)
v4uint16 | extract_v4uint16 (v32uint16 v, int idx)
unsigned int | extract_elem (v16uint32 v, int idx)
v2uint32 | extract_v2uint32 (v16uint32 v, int idx)
cint16 | extract_elem (v16cint16 v, int idx)
v2cint16 | extract_v2cint16 (v16cint16 v, int idx)
cint32 | extract_elem (v8cint32 v, int idx)
bfloat16 | extract_elem (v32bfloat16 v, int idx)
v2bfloat16 | extract_v2bfloat16 (v32bfloat16 v, int idx)
v4bfloat16 | extract_v4bfloat16 (v32bfloat16 v, int idx)
int | extract_element (v32int32 v, int idx)
int | extract_element (v32acc32 v, int idx)
long long | extract_element (v16acc64 v, int idx)
int | ext_elem (v32int32 v, int idx)
int | ext_elem (v32acc32 v, int idx)
long long | ext_elem (v16acc64 v, int idx)

## Extract a 20 bit element (pointer) from a vector
  Extract element determined by idx from vector a Parameters
  a | The vector from which the element will be extracted from
  idx | Index used to choose element in vector
Returns unsigned 20 bit (lower bits) from the corresponding 32 bit vector element
void * | ext_address (v64int8 v, int idx)
void * | ext_address (v32int16 v, int idx)
void * | ext_address (v16int32 v, int idx)
void * | extract_address (v64int8 v, int idx)
void * | extract_address (v32int16 v, int idx)
void * | extract_address (v16int32 v, int idx)

## Data Structure Documentation

## ◆ cint16_cbfloat16_cnvt_t

union cint16_cbfloat16_cnvt_t

Data Fields
cbfloat16 | cbf16 |
int | ci16 |

## ◆ cint32_cfloat32_cnvt_t

union cint32_cfloat32_cnvt_t

Data Fields
cfloat | cf32 |
cint32 | ci32 |

## Function Documentation

## ◆ ext_address() [1/3]

void * ext_address | ( | v16int32 | v,
|  | int | idx )

## ◆ ext_address() [2/3]

void * ext_address | ( | v32int16 | v,
|  | int | idx )

## ◆ ext_address() [3/3]

void * ext_address | ( | v64int8 | v,
|  | int | idx )

## ◆ ext_elem() [1/21]

long long ext_elem | ( | v16acc64 | v,
|  | int | idx )

## ◆ ext_elem() [2/21]

cint16 ext_elem | ( | v16cint16 | v,
|  | int | idx )

## ◆ ext_elem() [3/21]

cint16 ext_elem | ( | v16cint16 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_elem() [4/21]

int ext_elem | ( | v16int32 | v,
|  | int | idx )

## ◆ ext_elem() [5/21]

int ext_elem | ( | v16int32 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_elem() [6/21]

unsigned int ext_elem | ( | v16uint32 | v,
|  | int | idx )

## ◆ ext_elem() [7/21]

unsigned int ext_elem | ( | v16uint32 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_elem() [8/21]

int ext_elem | ( | v32acc32 | v,
|  | int | idx )

## ◆ ext_elem() [9/21]

bfloat16 ext_elem | ( | v32bfloat16 | v,
|  | int | idx )

## ◆ ext_elem() [10/21]

bfloat16 ext_elem | ( | v32bfloat16 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_elem() [11/21]

short ext_elem | ( | v32int16 | v,
|  | int | idx )

## ◆ ext_elem() [12/21]

short ext_elem | ( | v32int16 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_elem() [13/21]

int ext_elem | ( | v32int32 | v,
|  | int | idx )

## ◆ ext_elem() [14/21]

unsigned short ext_elem | ( | v32uint16 | v,
|  | int | idx )

## ◆ ext_elem() [15/21]

unsigned short ext_elem | ( | v32uint16 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_elem() [16/21]

char ext_elem | ( | v64int8 | v,
|  | int | idx )

## ◆ ext_elem() [17/21]

char ext_elem | ( | v64int8 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_elem() [18/21]

unsigned char ext_elem | ( | v64uint8 | v,
|  | int | idx )

## ◆ ext_elem() [19/21]

unsigned char ext_elem | ( | v64uint8 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_elem() [20/21]

cint32 ext_elem | ( | v8cint32 | v,
|  | int | idx )

## ◆ ext_elem() [21/21]

cint32 ext_elem | ( | v8cint32 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_u64() [1/10]

unsigned long long ext_u64 | ( | v128int4 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_u64() [2/10]

unsigned long long ext_u64 | ( | v128uint4 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_u64() [3/10]

unsigned long long ext_u64 | ( | v16cint16 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_u64() [4/10]

unsigned long long ext_u64 | ( | v16int32 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_u64() [5/10]

unsigned long long ext_u64 | ( | v16uint32 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_u64() [6/10]

unsigned long long ext_u64 | ( | v32bfloat16 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_u64() [7/10]

unsigned long long ext_u64 | ( | v32int16 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_u64() [8/10]

unsigned long long ext_u64 | ( | v32uint16 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_u64() [9/10]

unsigned long long ext_u64 | ( | v64int8 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_u64() [10/10]

unsigned long long ext_u64 | ( | v64uint8 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v16int4() [1/2]

v16int4 ext_v16int4 | ( | v128int4 | v,
|  | int | idx )

## ◆ ext_v16int4() [2/2]

v16int4 ext_v16int4 | ( | v128int4 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v16uint4() [1/2]

v16uint4 ext_v16uint4 | ( | v128uint4 | v,
|  | int | idx )

## ◆ ext_v16uint4() [2/2]

v16uint4 ext_v16uint4 | ( | v128uint4 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v2bfloat16() [1/2]

v2bfloat16 ext_v2bfloat16 | ( | v32bfloat16 | v,
|  | int | idx )

## ◆ ext_v2bfloat16() [2/2]

v2bfloat16 ext_v2bfloat16 | ( | v32bfloat16 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v2cint16() [1/2]

v2cint16 ext_v2cint16 | ( | v16cint16 | v,
|  | int | idx )

## ◆ ext_v2cint16() [2/2]

v2cint16 ext_v2cint16 | ( | v16cint16 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v2int16() [1/2]

v2int16 ext_v2int16 | ( | v32int16 | v,
|  | int | idx )

## ◆ ext_v2int16() [2/2]

v2int16 ext_v2int16 | ( | v32int16 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v2int32() [1/2]

v2int32 ext_v2int32 | ( | v16int32 | v,
|  | int | idx )

## ◆ ext_v2int32() [2/2]

v2int32 ext_v2int32 | ( | v16int32 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v2int4() [1/2]

v2int4 ext_v2int4 | ( | v128int4 | v,
|  | int | idx )

## ◆ ext_v2int4() [2/2]

v2int4 ext_v2int4 | ( | v128int4 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v2int8() [1/2]

v2int8 ext_v2int8 | ( | v64int8 | v,
|  | int | idx )

## ◆ ext_v2int8() [2/2]

v2int8 ext_v2int8 | ( | v64int8 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v2uint16() [1/2]

v2uint16 ext_v2uint16 | ( | v32uint16 | v,
|  | int | idx )

## ◆ ext_v2uint16() [2/2]

v2uint16 ext_v2uint16 | ( | v32uint16 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v2uint32()

v2uint32 ext_v2uint32 | ( | v16uint32 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v2uint4() [1/2]

v2uint4 ext_v2uint4 | ( | v128uint4 | v,
|  | int | idx )

## ◆ ext_v2uint4() [2/2]

v2uint4 ext_v2uint4 | ( | v128uint4 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v2uint8() [1/2]

v2uint8 ext_v2uint8 | ( | v64uint8 | v,
|  | int | idx )

## ◆ ext_v2uint8() [2/2]

v2uint8 ext_v2uint8 | ( | v64uint8 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v4bfloat16() [1/2]

v4bfloat16 ext_v4bfloat16 | ( | v32bfloat16 | v,
|  | int | idx )

## ◆ ext_v4bfloat16() [2/2]

v4bfloat16 ext_v4bfloat16 | ( | v32bfloat16 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v4int16() [1/2]

v4int16 ext_v4int16 | ( | v32int16 | v,
|  | int | idx )

## ◆ ext_v4int16() [2/2]

v4int16 ext_v4int16 | ( | v32int16 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v4int4() [1/2]

v4int4 ext_v4int4 | ( | v128int4 | v,
|  | int | idx )

## ◆ ext_v4int4() [2/2]

v4int4 ext_v4int4 | ( | v128int4 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v4int8() [1/2]

v4int8 ext_v4int8 | ( | v64int8 | v,
|  | int | idx )

## ◆ ext_v4int8() [2/2]

v4int8 ext_v4int8 | ( | v64int8 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v4uint16() [1/2]

v4uint16 ext_v4uint16 | ( | v32uint16 | v,
|  | int | idx )

## ◆ ext_v4uint16() [2/2]

v4uint16 ext_v4uint16 | ( | v32uint16 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v4uint4() [1/2]

v4uint4 ext_v4uint4 | ( | v128uint4 | v,
|  | int | idx )

## ◆ ext_v4uint4() [2/2]

v4uint4 ext_v4uint4 | ( | v128uint4 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v4uint8() [1/2]

v4uint8 ext_v4uint8 | ( | v64uint8 | v,
|  | int | idx )

## ◆ ext_v4uint8() [2/2]

v4uint8 ext_v4uint8 | ( | v64uint8 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v8int4() [1/2]

v8int4 ext_v8int4 | ( | v128int4 | v,
|  | int | idx )

## ◆ ext_v8int4() [2/2]

v8int4 ext_v8int4 | ( | v128int4 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v8int8() [1/2]

v8int8 ext_v8int8 | ( | v64int8 | v,
|  | int | idx )

## ◆ ext_v8int8() [2/2]

v8int8 ext_v8int8 | ( | v64int8 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v8uint4() [1/2]

v8uint4 ext_v8uint4 | ( | v128uint4 | v,
|  | int | idx )

## ◆ ext_v8uint4() [2/2]

v8uint4 ext_v8uint4 | ( | v128uint4 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_v8uint8() [1/2]

v8uint8 ext_v8uint8 | ( | v64uint8 | v,
|  | int | idx )

## ◆ ext_v8uint8() [2/2]

v8uint8 ext_v8uint8 | ( | v64uint8 | v,
|  | int | idx,
|  | int | sign )

## ◆ ext_vu2int32()

v2uint32 ext_vu2int32 | ( | v16uint32 | v,
|  | int | idx )

## ◆ extract_address() [1/3]

void * extract_address | ( | v16int32 | v,
|  | int | idx )

## ◆ extract_address() [2/3]

void * extract_address | ( | v32int16 | v,
|  | int | idx )

## ◆ extract_address() [3/3]

void * extract_address | ( | v64int8 | v,
|  | int | idx )

## ◆ extract_elem() [1/24]

cbfloat16 extract_elem | ( | v16cbfloat16 | v,
|  | int | idx )

## ◆ extract_elem() [2/24]

cbfloat16 extract_elem | ( | v16cbfloat16 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_elem() [3/24]

cint16 extract_elem | ( | v16cint16 | v,
|  | int | idx )

## ◆ extract_elem() [4/24]

cint16 extract_elem | ( | v16cint16 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_elem() [5/24]

float extract_elem | ( | v16float | v,
|  | int | idx )

## ◆ extract_elem() [6/24]

float extract_elem | ( | v16float | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_elem() [7/24]

int extract_elem | ( | v16int32 | v,
|  | int | idx )

## ◆ extract_elem() [8/24]

int extract_elem | ( | v16int32 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_elem() [9/24]

unsigned int extract_elem | ( | v16uint32 | v,
|  | int | idx )

## ◆ extract_elem() [10/24]

unsigned int extract_elem | ( | v16uint32 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_elem() [11/24]

bfloat16 extract_elem | ( | v32bfloat16 | v,
|  | int | idx )

## ◆ extract_elem() [12/24]

bfloat16 extract_elem | ( | v32bfloat16 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_elem() [13/24]

short extract_elem | ( | v32int16 | v,
|  | int | idx )

## ◆ extract_elem() [14/24]

short extract_elem | ( | v32int16 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_elem() [15/24]

unsigned short extract_elem | ( | v32uint16 | v,
|  | int | idx )

## ◆ extract_elem() [16/24]

unsigned short extract_elem | ( | v32uint16 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_elem() [17/24]

char extract_elem | ( | v64int8 | v,
|  | int | idx )

## ◆ extract_elem() [18/24]

char extract_elem | ( | v64int8 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_elem() [19/24]

unsigned char extract_elem | ( | v64uint8 | v,
|  | int | idx )

## ◆ extract_elem() [20/24]

unsigned char extract_elem | ( | v64uint8 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_elem() [21/24]

cfloat extract_elem | ( | v8cfloat | v,
|  | int | idx )

## ◆ extract_elem() [22/24]

cfloat extract_elem | ( | v8cfloat | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_elem() [23/24]

cint32 extract_elem | ( | v8cint32 | v,
|  | int | idx )

## ◆ extract_elem() [24/24]

cint32 extract_elem | ( | v8cint32 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_element() [1/3]

long long extract_element | ( | v16acc64 | v,
|  | int | idx )

## ◆ extract_element() [2/3]

int extract_element | ( | v32acc32 | v,
|  | int | idx )

## ◆ extract_element() [3/3]

int extract_element | ( | v32int32 | v,
|  | int | idx )

## ◆ extract_v16int4() [1/2]

v16int4 extract_v16int4 | ( | v128int4 | v,
|  | int | idx )

## ◆ extract_v16int4() [2/2]

v16int4 extract_v16int4 | ( | v128int4 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v16uint4() [1/2]

v16uint4 extract_v16uint4 | ( | v128uint4 | v,
|  | int | idx )

## ◆ extract_v16uint4() [2/2]

v16uint4 extract_v16uint4 | ( | v128uint4 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v2bfloat16() [1/2]

v2bfloat16 extract_v2bfloat16 | ( | v32bfloat16 | v,
|  | int | idx )

## ◆ extract_v2bfloat16() [2/2]

v2bfloat16 extract_v2bfloat16 | ( | v32bfloat16 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v2cint16() [1/2]

v2cint16 extract_v2cint16 | ( | v16cint16 | v,
|  | int | idx )

## ◆ extract_v2cint16() [2/2]

v2cint16 extract_v2cint16 | ( | v16cint16 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v2int16() [1/2]

v2int16 extract_v2int16 | ( | v32int16 | v,
|  | int | idx )

## ◆ extract_v2int16() [2/2]

v2int16 extract_v2int16 | ( | v32int16 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v2int32() [1/2]

v2int32 extract_v2int32 | ( | v16int32 | v,
|  | int | idx )

## ◆ extract_v2int32() [2/2]

v2int32 extract_v2int32 | ( | v16int32 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v2int4() [1/2]

v2int4 extract_v2int4 | ( | v128int4 | v,
|  | int | idx )

## ◆ extract_v2int4() [2/2]

v2int4 extract_v2int4 | ( | v128int4 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v2int8() [1/2]

v2int8 extract_v2int8 | ( | v64int8 | v,
|  | int | idx )

## ◆ extract_v2int8() [2/2]

v2int8 extract_v2int8 | ( | v64int8 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v2uint16() [1/2]

v2uint16 extract_v2uint16 | ( | v32uint16 | v,
|  | int | idx )

## ◆ extract_v2uint16() [2/2]

v2uint16 extract_v2uint16 | ( | v32uint16 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v2uint32() [1/2]

v2uint32 extract_v2uint32 | ( | v16uint32 | v,
|  | int | idx )

## ◆ extract_v2uint32() [2/2]

v2uint32 extract_v2uint32 | ( | v16uint32 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v2uint4() [1/2]

v2uint4 extract_v2uint4 | ( | v128uint4 | v,
|  | int | idx )

## ◆ extract_v2uint4() [2/2]

v2uint4 extract_v2uint4 | ( | v128uint4 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v2uint8() [1/2]

v2uint8 extract_v2uint8 | ( | v64uint8 | v,
|  | int | idx )

## ◆ extract_v2uint8() [2/2]

v2uint8 extract_v2uint8 | ( | v64uint8 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v4bfloat16() [1/2]

v4bfloat16 extract_v4bfloat16 | ( | v32bfloat16 | v,
|  | int | idx )

## ◆ extract_v4bfloat16() [2/2]

v4bfloat16 extract_v4bfloat16 | ( | v32bfloat16 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v4int16() [1/2]

v4int16 extract_v4int16 | ( | v32int16 | v,
|  | int | idx )

## ◆ extract_v4int16() [2/2]

v4int16 extract_v4int16 | ( | v32int16 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v4int4() [1/2]

v4int4 extract_v4int4 | ( | v128int4 | v,
|  | int | idx )

## ◆ extract_v4int4() [2/2]

v4int4 extract_v4int4 | ( | v128int4 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v4int8() [1/2]

v4int8 extract_v4int8 | ( | v64int8 | v,
|  | int | idx )

## ◆ extract_v4int8() [2/2]

v4int8 extract_v4int8 | ( | v64int8 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v4uint16() [1/2]

v4uint16 extract_v4uint16 | ( | v32uint16 | v,
|  | int | idx )

## ◆ extract_v4uint16() [2/2]

v4uint16 extract_v4uint16 | ( | v32uint16 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v4uint4() [1/2]

v4uint4 extract_v4uint4 | ( | v128uint4 | v,
|  | int | idx )

## ◆ extract_v4uint4() [2/2]

v4uint4 extract_v4uint4 | ( | v128uint4 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v4uint8() [1/2]

v4uint8 extract_v4uint8 | ( | v64uint8 | v,
|  | int | idx )

## ◆ extract_v4uint8() [2/2]

v4uint8 extract_v4uint8 | ( | v64uint8 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v8int4() [1/2]

v8int4 extract_v8int4 | ( | v128int4 | v,
|  | int | idx )

## ◆ extract_v8int4() [2/2]

v8int4 extract_v8int4 | ( | v128int4 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v8int8() [1/2]

v8int8 extract_v8int8 | ( | v64int8 | v,
|  | int | idx )

## ◆ extract_v8int8() [2/2]

v8int8 extract_v8int8 | ( | v64int8 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v8uint4() [1/2]

v8uint4 extract_v8uint4 | ( | v128uint4 | v,
|  | int | idx )

## ◆ extract_v8uint4() [2/2]

v8uint4 extract_v8uint4 | ( | v128uint4 | v,
|  | int | idx,
|  | int | sign )

## ◆ extract_v8uint8() [1/2]

v8uint8 extract_v8uint8 | ( | v64uint8 | v,
|  | int | idx )

## ◆ extract_v8uint8() [2/2]

v8uint8 extract_v8uint8 | ( | v64uint8 | v,
|  | int | idx,
|  | int | sign )

## ◆ get_hi()

float get_hi | ( | v1cfloat |  | ) |

## ◆ get_lo()

float get_lo | ( | v1cfloat |  | ) |

## ◆ insert() [1/46]

v128int4 insert | ( | v128int4 | v,
|  | int | idx,
|  | unsigned long long | b )

## ◆ insert() [2/46]

v128int4 insert | ( | v128int4 | v,
|  | int | idx,
|  | v16int4 | b )

## ◆ insert() [3/46]

v128int4 insert | ( | v128int4 | v,
|  | int | idx,
|  | v2int4 | b )

## ◆ insert() [4/46]

v128int4 insert | ( | v128int4 | v,
|  | int | idx,
|  | v4int4 | b )

## ◆ insert() [5/46]

v128int4 insert | ( | v128int4 | v,
|  | int | idx,
|  | v8int4 | b )

## ◆ insert() [6/46]

v128uint4 insert | ( | v128uint4 | v,
|  | int | idx,
|  | unsigned long long | b )

## ◆ insert() [7/46]

v128uint4 insert | ( | v128uint4 | v,
|  | int | idx,
|  | v16uint4 | b )

## ◆ insert() [8/46]

v128uint4 insert | ( | v128uint4 | v,
|  | int | idx,
|  | v2uint4 | b )

## ◆ insert() [9/46]

v128uint4 insert | ( | v128uint4 | v,
|  | int | idx,
|  | v4uint4 | b )

## ◆ insert() [10/46]

v128uint4 insert | ( | v128uint4 | v,
|  | int | idx,
|  | v8uint4 | b )

## ◆ insert() [11/46]

v16cbfloat16 insert | ( | v16cbfloat16 | v,
|  | int | idx,
|  | cbfloat16 | b )

## ◆ insert() [12/46]

v16cint16 insert | ( | v16cint16 | v,
|  | int | idx,
|  | cint16 | b )

## ◆ insert() [13/46]

v16cint16 insert | ( | v16cint16 | v,
|  | int | idx,
|  | unsigned long long | b )

## ◆ insert() [14/46]

v16cint16 insert | ( | v16cint16 | v,
|  | int | idx,
|  | v2cint16 | b )

## ◆ insert() [15/46]

v16float insert | ( | v16float | v,
|  | int | idx,
|  | float | b )

## ◆ insert() [16/46]

v16float insert | ( | v16float | v,
|  | int | idx,
|  | unsigned long long | b )

## ◆ insert() [17/46]

v16int32 insert | ( | v16int32 | v,
|  | int | idx,
|  | int | b )

## ◆ insert() [18/46]

v16int32 insert | ( | v16int32 | v,
|  | int | idx,
|  | unsigned long long | b )

## ◆ insert() [19/46]

v16int32 insert | ( | v16int32 | v,
|  | int | idx,
|  | v2int32 | b )

## ◆ insert() [20/46]

v16uint32 insert | ( | v16uint32 | v,
|  | int | idx,
|  | unsigned int | b )

## ◆ insert() [21/46]

v16uint32 insert | ( | v16uint32 | v,
|  | int | idx,
|  | unsigned long long | b )

## ◆ insert() [22/46]

v16uint32 insert | ( | v16uint32 | v,
|  | int | idx,
|  | v2uint32 | b )

## ◆ insert() [23/46]

v32bfloat16 insert | ( | v32bfloat16 | v,
|  | int | idx,
|  | bfloat16 | b )

## ◆ insert() [24/46]

v32bfloat16 insert | ( | v32bfloat16 | v,
|  | int | idx,
|  | unsigned long long | b )

## ◆ insert() [25/46]

v32bfloat16 insert | ( | v32bfloat16 | v,
|  | int | idx,
|  | v2bfloat16 | b )

## ◆ insert() [26/46]

v32bfloat16 insert | ( | v32bfloat16 | v,
|  | int | idx,
|  | v4bfloat16 | b )

## ◆ insert() [27/46]

v32int16 insert | ( | v32int16 | v,
|  | int | idx,
|  | int | b )

## ◆ insert() [28/46]

v32int16 insert | ( | v32int16 | v,
|  | int | idx,
|  | unsigned long long | b )

## ◆ insert() [29/46]

v32int16 insert | ( | v32int16 | v,
|  | int | idx,
|  | v2int16 | b )

## ◆ insert() [30/46]

v32int16 insert | ( | v32int16 | v,
|  | int | idx,
|  | v4int16 | b )

## ◆ insert() [31/46]

v32uint16 insert | ( | v32uint16 | v,
|  | int | idx,
|  | unsigned long long | b )

## ◆ insert() [32/46]

v32uint16 insert | ( | v32uint16 | v,
|  | int | idx,
|  | unsigned short | b )

## ◆ insert() [33/46]

v32uint16 insert | ( | v32uint16 | v,
|  | int | idx,
|  | v2uint16 | b )

## ◆ insert() [34/46]

v32uint16 insert | ( | v32uint16 | v,
|  | int | idx,
|  | v4uint16 | b )

## ◆ insert() [35/46]

v64int8 insert | ( | v64int8 | v,
|  | int | idx,
|  | int | b )

## ◆ insert() [36/46]

v64int8 insert | ( | v64int8 | v,
|  | int | idx,
|  | unsigned long long | b )

## ◆ insert() [37/46]

v64int8 insert | ( | v64int8 | v,
|  | int | idx,
|  | v2int8 | b )

## ◆ insert() [38/46]

v64int8 insert | ( | v64int8 | v,
|  | int | idx,
|  | v4int8 | b )

## ◆ insert() [39/46]

v64int8 insert | ( | v64int8 | v,
|  | int | idx,
|  | v8int8 | b )

## ◆ insert() [40/46]

v64uint8 insert | ( | v64uint8 | v,
|  | int | idx,
|  | unsigned char | b )

## ◆ insert() [41/46]

v64uint8 insert | ( | v64uint8 | v,
|  | int | idx,
|  | unsigned long long | b )

## ◆ insert() [42/46]

v64uint8 insert | ( | v64uint8 | v,
|  | int | idx,
|  | v2uint8 | b )

## ◆ insert() [43/46]

v64uint8 insert | ( | v64uint8 | v,
|  | int | idx,
|  | v4uint8 | b )

## ◆ insert() [44/46]

v64uint8 insert | ( | v64uint8 | v,
|  | int | idx,
|  | v8uint8 | b )

## ◆ insert() [45/46]

v8cfloat insert | ( | v8cfloat | v,
|  | int | idx,
|  | cfloat | b )

## ◆ insert() [46/46]

v8cint32 insert | ( | v8cint32 | v,
|  | int | idx,
|  | cint32 | b )

## ◆ insert_element() [1/3]

v16acc64 insert_element | ( | v16acc64 | v,
|  | int | idx,
|  | long long | b )

## ◆ insert_element() [2/3]

v32acc32 insert_element | ( | v32acc32 | v,
|  | int | idx,
|  | int | b )

## ◆ insert_element() [3/3]

v32int32 insert_element | ( | v32int32 | v,
|  | int | idx,
|  | int | b )

## ◆ upd_elem() [1/12]

v16acc64 upd_elem | ( | v16acc64 | v,
|  | int | idx,
|  | int | b )

## ◆ upd_elem() [2/12]

v16cint16 upd_elem | ( | v16cint16 | v,
|  | int | idx,
|  | cint16 | b )

## ◆ upd_elem() [3/12]

v16int32 upd_elem | ( | v16int32 | v,
|  | int | idx,
|  | int | b )

## ◆ upd_elem() [4/12]

v16uint32 upd_elem | ( | v16uint32 | v,
|  | int | idx,
|  | unsigned int | b )

## ◆ upd_elem() [5/12]

v32acc32 upd_elem | ( | v32acc32 | v,
|  | int | idx,
|  | int | b )

## ◆ upd_elem() [6/12]

v32bfloat16 upd_elem | ( | v32bfloat16 | v,
|  | int | idx,
|  | bfloat16 | b )

## ◆ upd_elem() [7/12]

v32int16 upd_elem | ( | v32int16 | v,
|  | int | idx,
|  | int | b )

## ◆ upd_elem() [8/12]

v32int32 upd_elem | ( | v32int32 | v,
|  | int | idx,
|  | int | b )

## ◆ upd_elem() [9/12]

v32uint16 upd_elem | ( | v32uint16 | v,
|  | int | idx,
|  | unsigned int | b )

## ◆ upd_elem() [10/12]

v64int8 upd_elem | ( | v64int8 | v,
|  | int | idx,
|  | int | b )

## ◆ upd_elem() [11/12]

v64uint8 upd_elem | ( | v64uint8 | v,
|  | int | idx,
|  | unsigned int | b )

## ◆ upd_elem() [12/12]

v8cint32 upd_elem | ( | v8cint32 | v,
|  | int | idx,
|  | cint32 | b )